<script setup lang="ts">
import type {
  OwnershipTransferRequestIn,
  ResourceOut,
  UserOut,
  WorkflowOut,
  BucketOut,
  OwnershipTransferRequestOut,
} from "@/client/types.gen";
import { OwnershipTypeEnum } from "@/client/types.gen";
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import { computed, onMounted, reactive, ref, watch } from "vue";
import SearchUserModal from "@/components/modals/SearchUserModal.vue";
import { Modal, Toast } from "bootstrap";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import { useNameStore } from "@/stores/names";
import { useOTRStore } from "@/stores/otrs";
import BootstrapToast from "@/components/BootstrapToast.vue";

type OtrTypes = BucketOut | WorkflowOut | ResourceOut;

const props = defineProps<{
  modalId: string;
  target: OtrTypes;
  backModalId?: string;
}>();
const randomIDSuffix = Math.random().toString(16).substring(2, 8);
let createOtrModal: Modal | null = null;
let successToast: Toast | null = null;

const nameRepository = useNameStore();
const otrRepository = useOTRStore();

const otrCreateForm = ref<HTMLFormElement | undefined>(undefined);

const formState = reactive<{
  validated: boolean;
  requestIn: OwnershipTransferRequestIn;
  otrExists?: OwnershipTransferRequestOut;
}>({
  validated: false,
  requestIn: {
    new_owner_uid: "",
    comment: undefined,
  },
  otrExists: undefined,
});

const targetType = computed<OwnershipTypeEnum>(() => {
  if (isResource(props.target)) {
    return OwnershipTypeEnum.RESOURCE;
  } else if (isWorkflow(props.target)) {
    return OwnershipTypeEnum.WORKFLOW;
  }
  return OwnershipTypeEnum.BUCKET;
});

const targetName = computed<string>(() => props.target.name);
const targetId = computed<string>(() => {
  if (isResource(props.target)) {
    return props.target.resource_id;
  } else if (isWorkflow(props.target)) {
    return props.target.workflow_id;
  } else if (isBucket(props.target)) {
    return props.target.name;
  }
  return "";
});

watch(targetId, (newId, oldId) => {
  if (newId !== oldId) {
    resetForm();
    checkOtrExists();
  }
});

function saveOtr() {
  if (!formState.otrExists) {
    formState.validated = true;
    formState.requestIn.comment = formState.requestIn.comment?.trim();
    if (otrCreateForm.value?.checkValidity()) {
      otrRepository
        .createOtr(targetId.value, formState.requestIn, targetType.value)
        .then((otr) => {
          createOtrModal?.hide();
          successToast?.show();
          resetForm();
          formState.otrExists = otr;
        });
    }
  }
}

function isBucket(toBeDetermined: OtrTypes): toBeDetermined is BucketOut {
  return !!(toBeDetermined as BucketOut).description;
}

function isWorkflow(toBeDetermined: OtrTypes): toBeDetermined is WorkflowOut {
  return !!(toBeDetermined as WorkflowOut).workflow_id;
}

function isResource(toBeDetermined: OtrTypes): toBeDetermined is ResourceOut {
  return !!(toBeDetermined as ResourceOut).resource_id;
}

function updateUser(user: UserOut) {
  formState.requestIn.new_owner_uid = user.uid;
}

function resetForm() {
  formState.validated = false;
  formState.requestIn.new_owner_uid = "";
  formState.requestIn.comment = undefined;
}

function checkOtrExists() {
  if (targetId.value.length > 0) {
    otrRepository
      .fetchOtr(targetType.value, targetId.value)
      .then((otr) => {
        formState.otrExists = otr;
      })
      .catch(() => {
        formState.otrExists = undefined;
      });
  } else {
    formState.otrExists = {
      target_id: "",
      new_owner_uid: "",
      target_description: "",
      target_name: "",
      target_type: targetType.value,
      created_at: 0,
    };
  }
}

onMounted(() => {
  createOtrModal = Modal.getOrCreateInstance(`#${props.modalId}`);
  successToast = Toast.getOrCreateInstance("#create-otr-success-toast");
  checkOtrExists();
});
</script>

<template>
  <bootstrap-toast toast-id="create-otr-success-toast" color-class="success">
    Successfully created request for {{ targetType }} {{ targetName }}
  </bootstrap-toast>
  <search-user-modal
    :modal-id="`search-user-for-otr-modal-${randomIDSuffix}`"
    :back-modal-id="props.modalId"
    :filter-user-self="true"
    @user-found="updateUser"
  />
  <bootstrap-modal
    :modal-id="props.modalId"
    :static-backdrop="true"
    size-modifier-modal="lg"
    :modal-label="`Create ${targetType} OTR`"
  >
    <template #header
      >Create Ownership transfer request for {{ targetType }}
      <b>{{ targetName }}</b></template
    >
    <template #body>
      <div v-if="formState.otrExists != undefined" class="text-center">
        <div>
          <i>A transfer request already exists for this {{ targetType }}.</i>
        </div>
        <div class="d-flex align-items-center justify-content-center">
          <span v-if="formState.otrExists.current_owner_uid">{{
            nameRepository.getName(formState.otrExists.current_owner_uid)
          }}</span
          ><span v-else>None</span><span class="mx-4 fs-4">&#8594;</span
          >{{ nameRepository.getName(formState.otrExists.new_owner_uid) }}
        </div>
        <div v-if="formState.otrExists.comment">
          {{ formState.otrExists.comment }}
        </div>
      </div>
      <form
        id="create-otr-form"
        ref="otrCreateForm"
        :class="{ 'was-validated': formState.validated }"
        :hidden="formState.otrExists != undefined"
        @submit.prevent="saveOtr"
      >
        <div class="m-1">
          <label for="create-otr-user-search" class="form-label"
            >Name of the new owner</label
          >
          <div class="input-group">
            <div class="input-group-text">
              <font-awesome-icon icon="fa-solid fa-user" />
            </div>
            <input
              id="create-otr-user-search"
              type="text"
              class="form-control"
              readonly
              :value="nameRepository.getName(formState.requestIn.new_owner_uid)"
              placeholder="Search for new owner"
              data-bs-toggle="modal"
              :data-bs-target="`#search-user-for-otr-modal-${randomIDSuffix}`"
            />
          </div>
        </div>
        <div class="m-1">
          <label for="create-otr-comment" class="form-label"> Comment </label>
          <div class="input-group">
            <textarea
              id="create-otr-comment"
              v-model="formState.requestIn.comment"
              class="form-control"
              rows="2"
              maxlength="265"
              placeholder="Optional comment for this request"
            ></textarea>
          </div>
        </div>
      </form>
    </template>
    <template #footer>
      <button
        v-if="!formState.otrExists"
        type="submit"
        form="create-otr-form"
        class="btn btn-success"
        :disabled="formState.requestIn.new_owner_uid.length === 0"
      >
        Save
      </button>
      <button
        type="button"
        class="btn btn-secondary"
        :data-bs-target="backModalId ? `#${backModalId}` : undefined"
        :data-bs-toggle="backModalId ? 'modal' : undefined"
        :data-bs-dismiss="backModalId ? undefined : 'modal'"
      >
        <template v-if="backModalId">Back</template>
        <template v-else>Close</template>
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
